/*!
 * Library for making Minesweeper clones
 * https://github.com/binaryluke/Minesweeper
 *
 * Copyright 2015, Luke Howard (@binaryluke)
 *
 * Released under the MIT license
 * http://lukehoward.name/project/minesweeper/license
 */
!function(){"use strict";var t={CLOSED:0,OPEN:1},o={NONE:0,EXCLAMATION:1,QUESTION:2},i={PRISTINE:0,IN_PROGRESS:1,LOST:2,WON:3},e=function(i,e,n,s){this.x=i||0,this.y=e||0,this.isMine=n?!0:!1,this.numAdjacentMines=s||0,this.state=t.CLOSED,this.flag=o.NONE},n=function(t){var o;try{o=f(t)}catch(e){o=!1}if(!o)throw new Error("The mine array supplied to Board constructor was not valid");this._state=i.PRISTINE,this._numRows=t.length,this._numCols=t[0].length,this._numMines=r(t,this._numRows,this._numCols),this._grid=l(t,this._numRows,this._numCols)};n.prototype.state=function(){return this._state},n.prototype.numRows=function(){return this._numRows},n.prototype.numCols=function(){return this._numCols},n.prototype.numMines=function(){return this._numMines},n.prototype.grid=function(){var t,o,i=[];for(t=0;t<this._numRows;t++)for(i.push([]),o=0;o<this._numCols;o++)i[t].push(this.cell(o,t));return this._grid},n.prototype._cell=function(t,o){return t>=0&&o>=0&&o<this._numRows&&t<this._numCols?this._grid[o][t]:void 0},n.prototype.cell=function(t,o){return _({},this._cell(+t,+o))},n.prototype.cycleCellFlag=function(e,n){var s=this._cell(+e,+n),l=!0;s&&s.state!==t.OPEN&&this._state!==i.WON&&this._state!==i.LOST&&(s.flag===o.NONE?s.flag=o.EXCLAMATION:s.flag===o.EXCLAMATION?s.flag=o.QUESTION:s.flag===o.QUESTION?s.flag=o.NONE:l=!1,l&&this._state===i.PRISTINE&&(this._state=i.IN_PROGRESS),this._updateState())},n.prototype.openCell=function(e,n){var s=this._cell(e,n);s&&s.state!==t.OPEN&&s.flag===o.NONE&&this._state!==i.WON&&this._state!==i.LOST&&(s.state=t.OPEN,s.isMine||(this._floodFill(e+1,n),this._floodFill(e-1,n),this._floodFill(e,n+1),this._floodFill(e,n-1),this._floodFill(e+1,n+1),this._floodFill(e-1,n-1),this._floodFill(e-1,n+1),this._floodFill(e+1,n-1)),this._state===i.PRISTINE&&(this._state=i.IN_PROGRESS),this._updateState())},n.prototype._floodFill=function(i,e){var n=this._cell(i,e);n&&!n.isMine&&n.state===t.CLOSED&&n.flag===o.NONE&&(n.state=t.OPEN,0===n.numAdjacentMines&&(this._floodFill(i+1,e),this._floodFill(i-1,e),this._floodFill(i,e+1),this._floodFill(i,e-1),this._floodFill(i+1,e+1),this._floodFill(i-1,e-1),this._floodFill(i-1,e+1),this._floodFill(i+1,e-1)))},n.prototype._updateState=function(){var e,n,s,l=!0;for(n=0;n<this._numRows;n++)for(e=0;e<this._numCols;e++)if(s=this._cell(e,n),s.state===t.OPEN){if(s.isMine)return void(this._state=i.LOST)}else s.state===t.CLOSED&&(s.isMine?s.flag!==o.EXCLAMATION&&(l=!1):l=!1);l&&(this._state=i.WON)};var s=function(t){var o,i,e,n,s,l=[];for(t=t||{},e=t.rows||10,n=t.cols||t.rows||10,s=t.mines||parseInt(e*n*.15,10)||0,i=e*n,o=0;i>o;o++)s>o?l.push(1):l.push(0);return l=u(l),l=a(l,n)},l=function(t,o,i){var n,s,l=[];for(s=0;o>s;s++)for(l[s]=[],n=0;i>n;n++)l[s][n]=new e(n,s,1===t[s][n]?!0:!1,h(t,n,s));return l},r=function(t,o,i){var e,n,s=0;for(n=0;o>n;n++)for(e=0;i>e;e++)1===t[n][e]&&s++;return s},h=function(t,o,i){var e,n,s=o+1,l=i+1,r=t[0].length,h=t.length,f=0;for(n=i-1;l>=n;n++)for(e=o-1;s>=e;e++)(n!==i||e!==o)&&n>=0&&e>=0&&h>n&&r>e&&1===t[n][e]&&f++;return f},f=function(t){var o,i,e,n,s=!0;if(t&&t.length)for(e=t.length,n=t[0]?t[0].length:0,0===n&&(s=!1),o=0;e>o;o++)if(t[o].length!==n)s=!1;else for(i=0;n>i;i++)0!==t[o][i]&&1!==t[o][i]&&(s=!1);else s=!1;return s},u=function(t){for(var o,i,e=t.length;e;)i=Math.floor(Math.random()*e--),o=t[e],t[e]=t[i],t[i]=o;return t},a=function(t,o){var i,e=t.length/o,n=[];for(i=0;e>i;i++)n.push(t.splice(0,o));return n},_=function(t,o){var i,e={};for(i in t)Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);for(i in o)Object.prototype.hasOwnProperty.call(o,i)&&(e[i]=o[i]);return e},c={Cell:e,CellStateEnum:t,CellFlagEnum:o,Board:n,BoardStateEnum:i,generateMineArray:s};"undefined"!=typeof module&&"undefined"!=typeof module.exports?module.exports=c:"function"==typeof define&&define.amd?define([],function(){return c}):window.minesweeper=c}();